
// FILE: findMin.cpp

#include <iostream.h>
#include <exception.h>
#include "printArray.h"
#include "findMin.h"

void doTest(int num[], int len);
int findMin2(int num[], int length);

void testMin()
{
	try {
		int a0[] = { 5, 6, 7, 3, 9, 4, 4, 13 };
		doTest(a0,8);
		doTest(a0+3,5);
		doTest(a0,0);
	} catch (xmsg(err)) {
		cerr << "exception: " << err.why() << endl;
	}
}

void doTest(int num[], int len)
{
	cout << "findMin2(";
	printArray(cout,num,len);
	cout << ", " << len << ") = " << findMin2(num,len) << endl;
}

// Requires: num[] a non-empty array with size length > 0
// Ensures: result is min element of num[]
int findMin(int num[], int length)
{
	if (length <= 0) {
		// gack! error!!!
		throw(xmsg("findMin() called with empty array!"));
	} else if (length == 1) {
		// base case is trivial:
		return num[0];
	} else {
		// assumes length >= 2
		int l1 = length/2;
		int l2 = length - l1;
		// both l1 and l2 >= 1 but < length
		int m1 = findMin(num, l1);
		int m2 = findMin(num+l1, l2);
		return (m1<m2) ? m1 : m2;
	}
}

// Requires: num[] a non-empty array with size length > 0
// Ensures: result is min element of num[]
int findMin2(int num[], int length)
{
	if (length <= 0) {
		// gack! error!!!
		throw(xmsg("findMin() called with empty array!"));
	}
	int min = num[0];
	int i;
	for (i=1; i<length; i++) {
		min = (min<num[i]) ? min : num[i];
	}
	return min;
}
