
/*
	File: AStack.h
	(c) Oscar Nierstrasz 30.3.96
*/

#ifndef ASTACK_H
#define ASTACK_H

#include <exception.h>
#include "Array.h"

template <class Item>
class AStack
{
	public:
		AStack (void) : stack(0) { } ;
		~AStack (void) { } ;
	
		// inline functions:
		int count (void) { return stack.size(); };
		int empty (void) { return stack.size() == 0; };
	
		void push (Item& item) throw(xmsg);
		Item& top (void) throw(xmsg) { return stack[stack.size() - 1]; }
		void pop (void) throw(xmsg) { stack.resize(stack.size() - 1); }

	private:
		Array<Item> stack;
};

template <class Item>
void
AStack<Item>::push (Item& item)
{
	stack.resize(stack.size() + 1);
	top() = item;
}

#endif // ASTACK_H

