/*
	dec.C -- simple application decorator to augment STL stacks
*/

#include <iostream.h>
#include <stack.h>
#include <vector.h>

void stackTest(void);

int main(void)
{
	stackTest();
	return 0;
}

#include <assert.h>

template <class Stack>
class decStack {
public:
	typedef Stack::value_type value_type;
	typedef Stack::size_type size_type;
public:
	bool empty() const { return s.empty(); }
	size_type size() const { return s.size(); }
	value_type& top() {
		assert(s.size() > 0);
		return s.top();
	}
	const value_type& top() const {
		assert(s.size() > 0);
		return s.top();
	}
	void push(const value_type& x) { s.push(x); }
	void pop() {
		assert(s.size() > 0);
		s.pop();
	}
private:
	Stack s;
};

// typedef stack<vector<int> > iStack;
typedef decStack<stack<vector<int> > > iStack;

void stackStats(iStack& is);

void stackTest(void)
{
	iStack istack;

	cout << "istack.size() = " << istack.size() << endl;
	cout << "istack.push(3)" << endl;
	istack.push(3);
	stackStats(istack);

	cout << "istack.push(5)" << endl;
	istack.push(5);
	stackStats(istack);

	cout << "istack.pop()" << endl;
	istack.pop();
	stackStats(istack);

	cout << "istack.pop()" << endl;
	istack.pop();
	stackStats(istack);

	cout << "istack.pop()" << endl;
	istack.pop();
	stackStats(istack);
}

void stackStats(iStack& istack)
{
	cout << "istack.size() = " << istack.size()
		<< "; istack.top() = " << istack.top() << endl;
}

