
/*
	File: gmkMain.cpp
	Author: Oscar Nierstrasz 18.3.96
	
	Driver for Go-moku program
*/


#include "BoardGame.h"
#include "Gomoku.h"
#include "TicTacToe.h"
#include "String.h"

BoardGame* makeGame (void);
void playGame (BoardGame&);

int main (void)
{	
	cout << "Welcome to The Board Game!" << endl;
	cout << "Would you like to play a game? (y/n): ";
	
	String reply;
	cin >> reply;
	
	while (reply.strlen() == 0 || reply[0] == 'y')  {
		BoardGame * game;
		game = makeGame();

		playGame(*game);
		delete game;
		
		cout << "Would you like to play another game? (y/n): ";
		cin >> reply;
	}
	cout << "Goodbye!" << endl;
	return 0; // Unix process terminates without error
}

BoardGame*
makeGame (void)
{
	cout << "What game would you like to play?" << endl;
	cout << "Tic Tac Toe (t) or Go-moku (g)?: ";
	String reply;
	cin >> reply;
	
	if (reply.strlen() == 0) {
		reply = "t"; // empty reply => tictactoe
	}
	
	switch (reply[0])  {
	  case 't' :
		return new TicTacToe;
		break;
	  case 'g' :
		return new Gomoku;
		break;
	  default:
		cout << "Hm ... I guess you want to play Tic Tac Toe ..." << endl;
		return new TicTacToe;
	}
}

void
playGame (BoardGame& game)
{
	String move; // Use our String class?
	
	while (game.notover())  {
		// game.print();
		cout << game << game.turn() << " plays: ";
		cin >> move;
		try  {
			if (move.strlen() > 0) {
				if (move[0] == 'q')  {
					cout << "Are you sure you want to quit this game? (y/n):";
					cin >> move;
					if (move.strlen() == 0) return;
					if (move[0] == 'y') return;
				}
			}
			game.play(move);
		}
		catch (xmsg &err) {
			cout << "Error: " << err.why() << endl; // or err.why()
		}
	}
	// game.print();
	cout << game << game.winner() << " wins!!!" << endl << endl;
}
