
/*
	lfib.C -- a lazy Fibonacci function
*/

#include <iostream.h>
#include <stdlib.h>	// for atoi()

#include "lazy.h"

// #define DEBUG

// int lfib(int);

typedef LazyList<int> LazyIntList;

int computeFib(int n, LazyIntList& fibList);
LazyIntList lfib(computeFib);

void fib40(void);

int main(int argc, char* argv[])
{
	if (argc <= 1) {
		cout << "no args" << endl;
		fib40();
	} else {
		int i;
		for (i=1; i<argc; i++) {
			// cout << "argc[" << i << "] = " << argv[i] << endl;
			cout << "lfib(" << argv[i] << ") = "
				<< lfib(atoi(argv[i])) << endl;
		}
	}
	return 0;
}

/*
int
lfib (int n)
{
	static LazyIntList fibList(computeFib);
	return fibList(n);
}
*/

int
computeFib(int n, LazyIntList& fibList)
{
#ifdef DEBUG
	cerr << "computing fib(" << n << ")" << endl;
#endif
	switch (n) {
	case 0 :
	case 1 :
		return 1;
		break;
	default :
		return fibList(n-1) + fibList(n-2);
		break;
	}
}

void fib40(void)
{
	int i;
	for (i=0;i<=40;i++) {
		cout << "lfib(" << i << ") = " << lfib(i) << endl;
	}
}

