
// File: cpprev.cpp
// Author: Oscar Nierstrasz 30.11.95
// Reverses the order of lines in the input using a dynamic stack.
// The stack is implemented as a linked list.

#include <iostream.h>
#include <exception.h>

#include "dstack.h"

const int bufSize = 256;

int main(void)
{
	DStack ioStack;
	char * buf;

	try {
		buf = new char[bufSize];
		//
		// Push input lines onto stack
		//
		while (!cin.getline(buf, bufSize).eof()) {
			ioStack.push(buf);
			buf = new char[bufSize];
		}

		//
		// Pop them off in reverse order
		// and print them all
		//
		while (ioStack.count() != 0) {
			cout << ioStack.top() << endl;;
			delete [] ioStack.top();
			ioStack.pop();
		}
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
		return -1;
	}
	return 0;
}

