
// File: dstack.cpp
// Author: Oscar Nierstrasz 30.11.95
// An absolutely minimal stack implementation using linked lists.

#include "dstack.h"

// constructor for an empty stack:
DStack::DStack (void)
	: size(0), topCell(0)
{
}

// destructor pops all cells:
DStack::~DStack(void)
{
	while (!this->empty()) {
		this->pop();
	}
}

// push makes a new top cell holding the new value
// and pointing to the existing chain of cells:
void
DStack::push(Item item)
{
	Cell *newCell;
	newCell = new Cell;
	newCell->value = item;
	newCell->next = this->topCell;
	this->topCell = newCell;
	size++;
}

// this is the only way to get values from the stack:
Item
DStack::top(void) throw(xmsg)
{
	if (this->empty()) {
		throw(xmsg("Empty stack has no top!"));
	}
	return this->topCell->value;
}

// deallocates the top cell and resets the top:
void
DStack::pop(void) throw(xmsg)
{
	if (this->empty()) {
		throw(xmsg("Can't pop an empty stack!"));
	}
	Cell *oldTop = topCell;
	topCell = topCell->next;
	delete oldTop;
	size--;
}
