
/*
	File: crev.c
	A C implementation of the line reverser program.
*/

#include <stdlib.h>
#include <stdio.h>

int main (void)
{
	const int bufSize = 256, stackSize = 32000;
	char *buf, **stack;
	int top=0;

	stack = (char**) malloc(sizeof(char*) * stackSize);
	buf = (char*) malloc(sizeof(char) * bufSize);
	stack[top] = buf;

	while (fgets(buf, bufSize, stdin) != NULL) {
		if (top>stackSize) {
			fprintf(stderr, "frev: buffer overflow!!!\n");
			exit(-1);
		}
		buf = (char*) malloc(sizeof(char) * bufSize);
		stack[++top] = buf;
	}

	/*
		don't use last allocated top since not null-terminated
	*/
	free(stack[top--]);
	while (top>=0) {
		printf("%s", stack[top]);
		free(stack[top--]);
	}
	return 0;
}

