
/*
	A C-like C++ implementation of the line reverser program.
*/

#include <iostream.h>
#include <stdlib.h>

int main (void)
{
	const int bufSize = 256, stackSize = 32000;
	char c, *buf, **stack;
	int l=0, top=0;

	stack = new char*[stackSize];
	stack[top] = (buf = new char[bufSize]);

	while ((c = cin.get()) != EOF) {
		if ((top>stackSize) || (l>bufSize)) {
			cerr << "frev: buffer overflow!!!" <<endl;
			exit(-1);
		}
		if (c == '\n') {
			buf[l++] = '\0';
			stack[++top] = (buf = new char[bufSize]);
			l = 0;
		}
		else {
			buf[l++] = c;
		}
	}

	delete [] stack[top--];
	while (top>=0) {
		cout << stack[top] << endl;
		delete [] stack[top--];
	}
	return 0;
}
