
/*
	A C-like C++ implementation of the line reverser program.
	This is apure C program if both STDIO and MALLOC are defined.
*/

#ifdef STDIO
#include <stdio.h>
#else
#include <iostream.h>
#endif

#ifdef MALLOC
#include <malloc.h>
#endif

#include <stdlib.h>

int main (void)
{
	const int bufSize = 256, stackSize = 32000;
	char c, *buf, **stack;
	int l=0, top=0;

#ifdef MALLOC
	stack = (char**) malloc(sizeof(char*)*stackSize);
	buf = (char*) malloc(sizeof(char)*bufSize);
	stack[top] = buf;
#else
	stack = new char*[stackSize];
	stack[top] = (buf = new char[bufSize]);
#endif

#ifdef STDIO
	while ((c = getchar()) != EOF) {
#else
	while ((c = cin.get()) != EOF) {
#endif
		if ((top>stackSize) || (l>bufSize)) {
#ifdef STDIO
			printf("frev: buffer overflow!!!\n");
#else
			cerr << "frev: buffer overflow!!!" <<endl;
#endif
			exit(-1);
		}
		if (c == '\n') {
			buf[l++] = '\0';
#ifdef MALLOC
			buf = (char*) malloc(sizeof(char)*bufSize);
			stack[++top] = buf;
#else
			stack[++top] = (buf = new char[bufSize]);
#endif
			l = 0;
		}
		else {
			buf[l++] = c;
		}
	}

#ifdef MALLOC
	free(stack[top--]);
#else
	delete [] stack[top--];
#endif
	while (top>=0) {
#ifdef STDIO
		printf("%s\n", stack[top]);
#else
		cout << stack[top] << endl;
#endif

#ifdef MALLOC
		free(stack[top--]);
#else
		delete [] stack[top--];
#endif
	}
	return 0;
}
