
/*
	FileArgsCommand is an abstract class that opens each of its
	constructor args as a file and calls the abstract command()
	on th eresulting input stream.  If no files args are passed,
	the default input stream is passed to command().
	Subclasses should call the super constructor and implement command()
*/

import java.io.*; // for DataInputStream etc.

public abstract class FileArgsCommand {

	public FileArgsCommand(String args[]) {
		if (args.length == 0) {
			command(System.in);
		} // else ...
		for (int i=0; i<args.length; i++) {
			try {
				InputStream in = new FileInputStream(args[i]);
				command(in);
				in.close();
			} catch (FileNotFoundException err) {
				System.err.println("FileArgsCommand: could'nt open " + args[i]);
			} catch (IOException err) { }
		}
	}
	
	protected abstract void command(InputStream in);
}
