
// File: drev.cpp
// Author: Oscar Nierstrasz 30.11.95

// Test program for dynamic stores
// Both the ioStack and the string abstraction are
// implemented with the template class DStore.

#include <iostream.h>
#include <exception.h>

#include "dstore.h"
#include "dstring.h"

typedef DStore<DString> Store;

void atest(Store& ioStack);
void ctest(Store& ioStack);

int main(void)
{
	Store ioStack;
	DString buf;

	try {
		// buf = new DString;
		while (buf.getline(cin)) {
			// cout << "Got: " << buf.val() << endl;
			// buf.stats();
			// tbuf = buf;
			// cout << "tbuf = " << tbuf.val() << endl;
			ioStack.push(buf); // NB: makes a copy of buf!
		}

		// DString tbuf = ioStack[0];
		// cout << "ioStack[0] = " << tbuf.val() << endl;
		// char c = tbuf[0];
		// cout << "first char: " << c << endl;

		// atest(ioStack);
		// ctest(ioStack);

		// cout << endl << "Test stack" << endl;
		while (ioStack.size() != 0) {
			cout << ioStack.top().val() << endl;
			ioStack.pop();
		}
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
	}

	// cout << endl << "END OF TESTS" << endl;
	return 0;
}

void atest(Store& ioStack)
{
	try {
		cout << endl << "Test assignment" << endl;

		Store copyStack;
		cout << "init size = " << copyStack.size() << endl;
		copyStack = ioStack; // test assignment
		cout << "after assgn size = " << copyStack.size() << endl;

		while (copyStack.size() != 0) {
			cout << copyStack.top().val() << endl;
			copyStack.pop();
		}
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
	}
}

void ctest(Store& ioStack)
{
	try {
		cout << endl << "Test copy constructor" << endl;

		Store * refStack;
		refStack = new Store(ioStack); // copy constructor

		while (refStack->size() != 0) {
			cout << refStack->top().val() << endl;
			refStack->pop();
		}
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
	}
}
