
// FILE: llist.h

#ifndef LLIST_H
#define LLIST_H

#include <iostream.h>
#include <exception.h>

// typedef char* Item; // Redefine as necessary (alternative to templates)

typedef int Item; // Redefine as necessary (alternative to templates)

class LList
{
public:
	// Warning: this Linked List class is *not* in orthodox canonical form!
	// Copying and assignment are not implemented
	
	LList(void);
	~LList(void);

	// inline functions:
	int count(void) { return size; };
	int empty(void) { return size == 0; };

	void push_front(Item item);
	Item front(void) throw(xmsg);
	void pop_front(void) throw(xmsg);

	void push_back(Item item);
	Item back(void) throw(xmsg);

	// quick & dirty print routine
	void print(ostream &os);
	
private:
	// LList(const LList&);				// not implemented
	LList& operator=(const LList&);
	
	class Cell
	{
	public:
		Cell(Item val, Cell *nxt) { value = val; next = nxt; }
		Item value;
		Cell *next;
	};

	// Invariant:
	// If size == 0, then frontCell == backCell == 0
	// Else frontCell points to first Cell, which points to the second etc.
	// If size > 0 then backCell->next == 0
	Cell *frontCell;
	Cell *backCell;
	int size;

};

inline ostream& operator<< (ostream& os, LList& ll) { ll.print(os); return os; }

#endif // LLIST_H
