
// FILE: testQueue.cpp

#include <iostream.h>
#include <exception.h>
#include "queue.h"
#include "testQueue.h"

// static void peekq(Queue &q);
static void peekq(Queue q);

void testQueue(void)
{
	Queue q;
	cout << "Testing queue operations" << endl;
	try {
		cout << "Initial queue = " << q << endl;
		q.enqueue(1); cout << q << endl;
		q.enqueue(2); cout << q << endl;
		
		// cout << "before peekq: queue = " << q << endl;
		// peekq(q);
		// cout << "after peekq: queue = " << q << endl;

		q.enqueue(3); cout << q << endl;
		q.dequeue(); cout << q << endl;
		q.enqueue(4); cout << q << endl;
		q.dequeue(); cout << q << endl;
		q.dequeue(); cout << q << endl;
		q.dequeue(); cout << q << endl;
		cout << "at end: queue = " << q << endl;
	} catch (xmsg &err) {
		cerr << "Exception: " << err.why() << endl;
	}
}

// A VERY VERY nasty bug occurs here if q is passed by value
// intead of by reference: since LList is not in OCF, a shallow copy
// will be made, and destructed when peekq() exits.
// Unfortunately the copy will destroy the original too!

// void peekq(Queue &q)
void peekq(Queue q)
{
	cout << "peekq: queue = " << q << endl;
}
