
// File: store.cpp
// Author: Oscar Nierstrasz 30.11.95

#include <iostream.h>

#include "store.h"

Store::~Store(void)
{
	delete [] _store;
}

Item& Store::index(const int n) const
{
	if (n >= curSize) {
		throw(xmsg("index too large"));
	}
	return this->_store[n];
}

Store& Store::operator=(const Store& val)
{
	if (this == &val) {
		return *this;
	}
	else {
		if (maxSize >= val.size()) {
			for (int i=0; i<curSize; i++) {
				_store[i] = val._store[i];
			}
		}
		else {
			delete[] _store;
			init(val,defSize);
		}
	}
}

void
Store::push(Item item)
{
	if (curSize == maxSize) {
		this->grow();
	}
	_store[curSize++] = item;
}

Item
Store::top(void) const
{
	if (this->empty()) {
		throw(xmsg("Empty stack has no top!"));
	}
	return _store[curSize-1];
}

void
Store::pop(void)
{
	if (this->empty()) {
		throw(xmsg("Can't pop an empty stack!"));
	}
	curSize--;
	//
	// if too small, then shrink ...
	//
}

void Store::grow(void)
{
	Item * oldStore;
	oldStore = _store;
	_store = makeStore(maxSize*2);
	maxSize = maxSize*2;
	for (int i=0; i<curSize; i++) {
		_store[i] = oldStore[i];
	}
	delete [] oldStore;
	return;
}

Item *
Store::makeStore(int newSize)
{
	Item * newStore = new Item[newSize];
	if (!newStore) {
		throw(xmsg("Store::makeStore: Couldn't allocate enough space"));
	}
	return newStore;
}

void
Store::init(const Store& val, int initSize)
{
	curSize = val.curSize;
	maxSize = (val.maxSize>initSize)?val.maxSize:initSize;
	_store = makeStore(maxSize);
	for (int i=0; i<curSize; i++) {
		_store[i] = val._store[i];
	}
}

void
Store::makeEmpty(int initSize)
{
	curSize = 0;
	maxSize = initSize;
	_store = makeStore(initSize);
}

