
// store.h
// Author: Oscar Nierstrasz 30.11.95
// A dynamic store modelled after Perl arrays

#ifndef STORE_H
#define STORE_H

#include <exception.h>
#include "store.h"

typedef char* Item; // Redefine as necessary (alternative to templates)

static const int defSize = 32;

class Store
{
public:
	Store(int initSize=defSize) { makeEmpty(initSize); } ;
	Store(const Store& copy) { init(copy,defSize); }; // copy constructor
	~Store(void);

	int size(void) const { return curSize; }
	int empty(void) const { return curSize == 0; };

	Item& index(const int n) const;

	Store& operator=(const Store&);

	void push(Item item); // throw();
	Item top(void) const; // throw(xmsg);
	void pop(void); // throw(xmsg);

	// Will also need shift, unshift ...

protected:
	int curSize;
	int maxSize;
	Item * _store;

	// Helper members:

	void grow(void);
	Item * makeStore(int);
	void init(const Store&, int);
	void makeEmpty(int);
};

#endif

