/*
	File: testString.cpp
*/

#include <iostream.h>
#include "String.h"

int main(void)
{
	try {
		String empty;
		cout << "Empty string:" << empty << ":" << endl;
		
		String howdy("howdy!");
		cout << "Char* initialized:" << howdy << ":" << endl;
		
		String str(howdy);
		cout << "String initialized:" << str << ":" << endl;
		
		String copy; // initially empty
		copy = howdy;
		cout << "Assigned string:" << copy << ":" << endl;
		
		// converted implicitly to:	
		// howdy = String("hello world");
		howdy = "hello world"; // NB: creates & destroys String!
		
		cout << "Re-assigned string:" << howdy << ":" << endl;
		cout << "Unaffected copy:" << copy << ":" << endl;
		
		copy = copy;
		cout << "Self copy:" << copy << ":" << endl;

		cout << "Length of hello world = " << howdy.strlen() << endl;
		// common error: howdy.strlen instead of howdy.strlen()
		
		String input;
		cout << "Enter string to read:";
		// input.getline(cin);
		cin >> input;
		cout << "Input string is:" << input << ":" << endl;
		cout << "First char is:" << input[0] << ":" << endl;
		cout << "Last char is:" << input[input.strlen() - 1] << ":" << endl;
		// error: input[input.strlen()]
		input[0] = 'X'; // not possible if operator[] is declared const
		// exception raised here if input is empty
		cout << "Modified input is:" << input << ":" << endl;
		
		
		String etc;
		cout << "Enter string to append:";
		cin >> etc;
		String target = input + etc;
		// not as efficient as target = input; target += etc;

		cout << "Concatenation is:" << target << ":" << endl;
	}
	catch (xmsg& err) {
		cout << "Exception caught: " << err.why() << endl;
	}
	cout << "END OF TESTS" << endl;
	return 0;
}
