
/*
	From C++ FAQs
	FAQ #144: "Can an overriden member function use a different
	default parameter than the one specified in the base class?"
*/

#include <iostream.h>

class Base
{
public:
	virtual ~Base(void) { };
	virtual void f(int i=5) { cout << "Base::f(int i); i = " << i << endl; }
};

class Derived : public Base
{
public:
	virtual void f(int i=7) { cout << "Derived::f(int i); i = " << i << endl; }
};

int
main(void)
{
	Derived d;
	Base* bp = &d;
	Derived* dp = &d;

	bp->f();	// Derived::f is called with default argument 5
	dp->f();

	return 0;
}

/*
	Output:

	Derived::f(int i); i = 5
	Derived::f(int i); i = 7
*/

