
// If you call a virtual method in an object during construction, the method
// is called as if the object were of the class that has the current scope.

// Example:

#include <iostream.h>

class Store;

class Base
{
public:
	Base (Store* store);
	virtual const char* myClass (void) { return "Base object"; }
};

class Derived : public Base
{
public:
	Derived (Store* store) : Base (store) { }
	const char* myClass (void) { return "Derived object"; }
};

class Store
{
public:
	void storeObject (Base* base) {
		myob = base;
		cout << "Got a new " << myob->myClass() << endl;
	}
	void printContents (void) {
		cout << "I now hold a " << myob->myClass() << endl;
	}
private:
	Base* myob;
};

Base::Base (Store* store) { store->storeObject(this); }

main(void)
{
	Store* store = new Store;
	Base* base = new Base (store);
	store->printContents();
	Derived* derived = new Derived (store);
	store->printContents();
}

// Output is:
/*
Got a new Base object
I now hold a Base object
Got a new Base object
I now hold a Derived object
*/

