
#include <iostream.h>
#include <string.h>

// not all compilers provide these:
typedef char bool;
const bool true = 1;
const bool false = 0;

void sizes(void);
void refs(void);
void strings(void);
void bools(void);
void exprs(void);
void blog(void);
void stmts(void);

int main(void)
{
	// blog();
	// exprs();
	// bools();
	// strings();
	// sizes();
	// refs();
	return(0);
}

void stmts(void)
{
	// if/else, for, while, do/while, switch
}

void exprs(void)
{
	int a, b, c;
	double d;
	float f;

	a = b = c = 7;
	a = (b == 7);		// a == 1
	b = !a;			// b == 0
	a = (b>=0) && (c<10);	// a == 1
	a *= (b += c++);	// a == 7; b == 7; c == 8

	a = 11 / 4;		// a == 2
	b = 11 % 4;		// b == 3
	cout << "a == " << a << "; b == " << b << endl;
	d = 11 / 4;		// d == 2.0
	f = 11.0 / 4.0;		// f == 2.75
	cout << "d == " << d << endl;
	cout << "f == " << f << endl;
	cout << "11/4 == " << 11.0/4.0 << endl;

	// a == 2; b == 3; c == 8
	a = b|c;		// a == 11
	b = a^c;		// b == 3
	c = a&b;		// c == 3

	b = a<<c;		// b == 88

	a = (b++,c--);		// a == 3; b == 89; c == 2
	cout << "a == " << a << "; b == " << b << "; c == " << c << endl;
	b = (a>c)?a:c;		// b == 3
	cout << "a == " << a << "; b == " << b << "; c == " << c << endl;
}

void blog(void)
{
	int n, i;
	do {
		cout << "Enter an integer (0 to quit): ";
		cin >> n;
		for(i=0; n >= 1<<i; i++);
		cout << "result: " << (i-1) << endl;
	} while(n>0);
}

void bools(void)
{
	bool b = true;
	if (b) cout << "true" << endl;
	else cout << "false" << endl;
}

void strings(void)
{
	char *cp;		// pointer to a char (string)
	char *hi = "hello";	// pointer to string
	char hello[6] = "hello";	// initialized char array
	// char hello[6] = hi;	// illegal!

	cp = hello;
	cp[1] = 'u';
	cp[4] = NULL;

	cout << "cp = " << cp << endl;
	cout << "sizeof(cp) = " << sizeof(cp) << endl;
	cout << "strlen(cp) = " << strlen(cp) << endl;

	cout << "hi = " << hi << endl;
	cout << "sizeof(hi) = " << sizeof(hi) << endl;
	cout << "strlen(hi) = " << strlen(hi) << endl;

	cout << "hello = " << hello << endl;
	cout << "sizeof(hello) = " << sizeof(hello) << endl;
	cout << "strlen(hello) = " << strlen(hello) << endl;
}

void refinc(int &i)
{
	i++;
}

void refs(void)
{
	int a=0;
	cout << "a = " << a << endl;
	refinc(a);
	cout << "a = " << a << endl;
}

void sizes(void)
{
	int a[4] = { 1, 2, 3, 4 };
	int *ap = a;
	void *vp = a;

	cout << "sizeof(a) = " << sizeof(a) << endl;
	cout << "sizeof(ap) = " << sizeof(ap) << endl;
	cout << "sizeof(vp) = " << sizeof(vp) << endl;
	cout << "a[0] = " << a[0] << endl;
	cout << "ap[0] = " << ap[0] << endl;
	cout << "vp[0] = " << ((int*)vp)[0] << endl;
}

